diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/boehm-gc/configure.ac gcc-4.0.1/boehm-gc/configure.ac
--- /usr1/rtems/work-tools/original/gcc-4.0.1/boehm-gc/configure.ac	Tue Feb 15 22:10:41 2005
+++ gcc-4.0.1/boehm-gc/configure.ac	Wed Aug 10 12:08:46 2005
@@ -186,6 +186,10 @@
 	;;
     esac
     ;;
+ rtems)
+    AC_DEFINE(GC_RTEMS_THREADS,1)
+    THREADLIBS=
+    ;;
  win32)
     AC_DEFINE(GC_WIN32_THREADS,1)
     dnl Old wine getenv may not return NULL for missing entry.
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/configure.in gcc-4.0.1/configure.in
--- /usr1/rtems/work-tools/original/gcc-4.0.1/configure.in	Wed Jun 22 15:41:56 2005
+++ gcc-4.0.1/configure.in	Wed Aug 10 12:08:46 2005
@@ -418,7 +418,7 @@
     noconfigdirs="$noconfigdirs target-newlib target-libiberty target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
-    noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
+    noconfigdirs="$noconfigdirs target-libgloss target-libiberty ${libgcj}"
     ;;
   *-*-uclinux*)
     noconfigdirs="$noconfigdirs target-newlib target-libgloss target-rda ${libgcj}"
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/c4x/rtems.h gcc-4.0.1/gcc/config/c4x/rtems.h
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/c4x/rtems.h	Wed Mar 12 22:06:51 2003
+++ gcc-4.0.1/gcc/config/c4x/rtems.h	Wed Aug 10 12:08:46 2005
@@ -24,6 +24,5 @@
 #define TARGET_OS_CPP_BUILTINS()		\
     do {					\
 	builtin_define ("__rtems__");		\
-	builtin_define ("__USE_INIT_FINI__");	\
 	builtin_assert ("system=rtems");	\
     } while (0)
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k-protos.h gcc-4.0.1/gcc/config/m68k/m68k-protos.h
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k-protos.h	Fri Oct 22 07:47:24 2004
+++ gcc-4.0.1/gcc/config/m68k/m68k-protos.h	Wed Aug 10 12:08:46 2005
@@ -53,6 +53,7 @@
 
 #endif /* RTX_CODE */
 
+extern bool m68k_regno_mode_ok (int, enum machine_mode);
 extern int flags_in_68881 (void);
 extern bool use_return_insn (void);
 extern void override_options (void);
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k.c gcc-4.0.1/gcc/config/m68k/m68k.c
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k.c	Wed Feb 23 19:50:33 2005
+++ gcc-4.0.1/gcc/config/m68k/m68k.c	Wed Aug 10 12:08:46 2005
@@ -3449,3 +3449,36 @@
 
   return 1;
 }
+
+/* Value is true if hard register REGNO can hold a value of machine-mode MODE.
+   On the 68000, the cpu registers can hold any mode except bytes in address
+   registers, but the 68881 registers can hold only SFmode or DFmode.  */
+bool
+m68k_regno_mode_ok (int regno, enum machine_mode mode)
+{
+  if (regno < 8)
+    {
+	/* Data Registers, can hold aggregate if fits in.  */
+	if (regno + GET_MODE_SIZE (mode) / 4 <= 8)
+	  return true;
+    }
+  else if (regno < 16)
+    {
+	/* Address Registers, can't hold bytes, can hold aggregate if
+	   fits in.  */
+	if (GET_MODE_SIZE (mode) == 1)
+	  return false;
+	if (regno + GET_MODE_SIZE (mode) / 4 <= 16)
+	  return true;
+    }
+  else if (regno < 24)
+    {
+      /* FPU registers, hold float or complex float of long double or
+	   smaller.  */
+	if ((GET_MODE_CLASS (mode) == MODE_FLOAT
+	     || GET_MODE_CLASS (mode) == MODE_COMPLEX_FLOAT)
+	    && GET_MODE_UNIT_SIZE (mode) <= 12)
+	  return true;
+    }
+  return false;
+}
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k.h gcc-4.0.1/gcc/config/m68k/m68k.h
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/m68k/m68k.h	Wed Dec 29 21:07:52 2004
+++ gcc-4.0.1/gcc/config/m68k/m68k.h	Wed Aug 10 12:08:46 2005
@@ -486,15 +486,12 @@
 #define HARD_REGNO_RENAME_OK(OLD_REG, NEW_REG) \
   m68k_hard_regno_rename_ok (OLD_REG, NEW_REG)
 
-/* On the m68k, the cpu registers can hold any mode but the 68881 registers
-   can hold only SFmode or DFmode.  */
+/* Value is 1 if hard register REGNO can hold a value of machine-mode MODE.
+   On the 68000, the cpu registers can hold any mode except bytes in
+   address registers, the 68881 registers can hold only SFmode or DFmode.  */
+
 #define HARD_REGNO_MODE_OK(REGNO, MODE) \
-  (((REGNO) < 16					\
-    && !((REGNO) < 8 && (REGNO) + GET_MODE_SIZE (MODE) / 4 > 8))	\
-   || ((REGNO) >= 16 && (REGNO) < 24				        \
-       && (GET_MODE_CLASS (MODE) == MODE_FLOAT		\
-	   || GET_MODE_CLASS (MODE) == MODE_COMPLEX_FLOAT)		\
-       && GET_MODE_UNIT_SIZE (MODE) <= 12))
+  m68k_regno_mode_ok ((REGNO), (MODE))
 
 #define MODES_TIEABLE_P(MODE1, MODE2)			\
   (! TARGET_68881					\
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/rtems.h gcc-4.0.1/gcc/config/rtems.h
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/config/rtems.h	Mon Jul  5 14:49:14 2004
+++ gcc-4.0.1/gcc/config/rtems.h	Wed Aug 10 12:08:46 2005
@@ -19,6 +19,7 @@
 Boston, MA 02111-1307, USA.  */
 
 /* The system headers under RTEMS are C++-aware.  */
+#undef NO_IMPLICIT_EXTERN_C
 #define NO_IMPLICIT_EXTERN_C
 
 /*
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/fortran/Make-lang.in gcc-4.0.1/gcc/fortran/Make-lang.in
--- /usr1/rtems/work-tools/original/gcc-4.0.1/gcc/fortran/Make-lang.in	Sat Nov 13 01:35:54 2004
+++ gcc-4.0.1/gcc/fortran/Make-lang.in	Wed Aug 10 12:08:46 2005
@@ -44,7 +44,7 @@
 GFORTRAN_INSTALL_NAME := $(shell echo gfortran|sed '$(program_transform_name)')
 
 # Actual name to use when installing a cross-compiler.
-GFORTRAN_CROSS_NAME := $(shell echo gfortran|sed '$(program_transform_cross_name)')
+GFORTRAN_TARGET_INSTALL_NAME := $(shell echo gfortran|sed '$(program_transform_name)')
 
 #^L
 
@@ -187,9 +187,9 @@
 f95.install-common: installdirs
 	-if [ -f f951$(exeext) ] ; then \
 	  if [ -f gfortran-cross$(exeext) ] ; then \
-	    rm -f $(DESTDIR)$(bindir)/$(GFORTRAN_CROSS_NAME)$(exeext); \
-	    $(INSTALL_PROGRAM) gfortran-cross$(exeext) $(DESTDIR)$(bindir)/$(GFORTRAN_CROSS_NAME)$(exeext); \
-	    chmod a+x $(DESTDIR)$(bindir)/$(GFORTRAN_CROSS_NAME)$(exeext); \
+	    rm -f $(DESTDIR)$(bindir)/$(GFORTRAN_TARGET_INSTALL_NAME)$(exeext); \
+	    $(INSTALL_PROGRAM) gfortran-cross$(exeext) $(DESTDIR)$(bindir)/$(GFORTRAN_TARGET_INSTALL_NAME)$(exeext); \
+	    chmod a+x $(DESTDIR)$(bindir)/$(GFORTRAN_TARGET_INSTALL_NAME)$(exeext); \
 	    if [ -d $(DESTDIR)$(gcc_tooldir)/bin/. ] ; then \
 	      rm -f $(DESTDIR)$(gcc_tooldir)/bin/gfortran$(exeext); \
 	      $(INSTALL_PROGRAM) gfortran-cross$(exeext) $(DESTDIR)$(gcc_tooldir)/bin/gfortran$(exeext); \
@@ -220,7 +220,7 @@
 	else : ; fi; \
 	rm -rf $(DESTDIR)$(bindir)/$(GFORTRAN_INSTALL_NAME)$(exeext); \
 	rm -rf $(DESTDIR)$(man1dir)/$(GFORTRAN_INSTALL_NAME)$(man1ext); \
-	rm -rf $(DESTDIR)$(bindir)/$(GFORTRAN_CROSS_NAME)$(exeext); \
+	rm -rf $(DESTDIR)$(bindir)/$(GFORTRAN_TARGET_INSTALL_NAME)$(exeext); \
 	rm -rf $(DESTDIR)$(infodir)/gfortran.info*
 
 #
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/libffi/configure.ac gcc-4.0.1/libffi/configure.ac
--- /usr1/rtems/work-tools/original/gcc-4.0.1/libffi/configure.ac	Thu Dec  2 05:04:21 2004
+++ gcc-4.0.1/libffi/configure.ac	Wed Aug 10 12:08:46 2005
@@ -46,6 +46,7 @@
 i*86-*-beos*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-freebsd* | i*86-*-kfreebsd*-gnu) TARGET=X86; TARGETDIR=x86;;
 i*86-*-netbsdelf* | i*86-*-knetbsd*-gnu) TARGET=X86; TARGETDIR=x86;;
+i*86-*-rtems*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-win32*) TARGET=X86_WIN32; TARGETDIR=x86;;
 i*86-*-cygwin*) TARGET=X86_WIN32; TARGETDIR=x86;;
 i*86-*-mingw*) TARGET=X86_WIN32; TARGETDIR=x86;;
@@ -53,11 +54,13 @@
 sparc-sun-4*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc*-sun-*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc-*-linux* | sparc-*-netbsdelf* | sparc-*-knetbsd*-gnu) TARGET=SPARC; TARGETDIR=sparc;;
+sparc*-*-rtems*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc64-*-linux* | sparc64-*-netbsd* | sparc64-*-knetbsd*-gnu) TARGET=SPARC; TARGETDIR=sparc;;
 alpha*-*-linux* | alpha*-*-osf* | alpha*-*-freebsd* | alpha*-*-kfreebsd*-gnu | alpha*-*-netbsd* | alpha*-*-knetbsd*-gnu) TARGET=ALPHA; TARGETDIR=alpha;;
 ia64*-*-*) TARGET=IA64; TARGETDIR=ia64;;
 m32r*-*-linux* ) TARGET=M32R; TARGETDIR=m32r;;
 m68k-*-linux*) TARGET=M68K; TARGETDIR=m68k;;
+m68k-*-rtems*) TARGET=M68K; TARGETDIR=m68k;;
 mips64*-*);;
 mips-sgi-irix5.* | mips-sgi-irix6.*) TARGET=MIPS_IRIX; TARGETDIR=mips;;
 mips*-*-linux*) TARGET=MIPS_LINUX; TARGETDIR=mips;;
@@ -65,13 +68,16 @@
 powerpc-*-beos*) TARGET=POWERPC; TARGETDIR=powerpc;;
 powerpc-*-darwin*) TARGET=POWERPC_DARWIN; TARGETDIR=powerpc;;
 powerpc-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
+powerpc*-*-rtems*) TARGET=POWERPC; TARGETDIR=powerpc;;
 rs6000-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
 arm*-*-linux-*) TARGET=ARM; TARGETDIR=arm;;
 arm*-*-netbsdelf* | arm*-*-knetbsd*-gnu) TARGET=ARM; TARGETDIR=arm;;
+arm*-*-rtems*) TARGET=ARM; TARGETDIR=arm;;
 s390-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 s390x-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 x86_64-*-linux* | x86_64-*-freebsd* | x86_64-*-kfreebsd*-gnu) TARGET=X86_64; TARGETDIR=x86;;
 sh-*-linux* | sh[[34]]*-*-linux*) TARGET=SH; TARGETDIR=sh;;
+sh-*-rtems*) TARGET=SH; TARGETDIR=sh;;
 sh64-*-linux* | sh5*-*-linux*) TARGET=SH64; TARGETDIR=sh64;;
 hppa-*-linux* | parisc-*-linux*) TARGET=PA; TARGETDIR=pa;;
 esac
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/Makefile.am gcc-4.0.1/libgfortran/Makefile.am
--- /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/Makefile.am	Wed Jun  1 18:02:14 2005
+++ gcc-4.0.1/libgfortran/Makefile.am	Wed Aug 10 12:08:46 2005
@@ -3,6 +3,7 @@
 
 ACLOCAL_AMFLAGS = -I ../config
 
+if LIBGFORTRAN
 toolexeclib_LTLIBRARIES = libgfortran.la libgfortranbegin.la
 
 libgfortran_la_LDFLAGS = -version-info `grep -v '^\#' $(srcdir)/libtool-version` -lm $(extra_ldflags_libgfortran)
@@ -527,3 +528,5 @@
 endif
 
 EXTRA_DIST = $(m4_files)
+
+endif
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/acinclude.m4 gcc-4.0.1/libgfortran/acinclude.m4
--- /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/acinclude.m4	Sun Dec 12 02:59:01 2004
+++ gcc-4.0.1/libgfortran/acinclude.m4	Wed Aug 10 12:08:46 2005
@@ -148,3 +148,20 @@
     AC_DEFINE(HAVE_ATTRIBUTE_ALIAS, 1,
       [Define to 1 if the target supports __attribute__((alias(...))).])
   fi])
+
+## Check whether the compiler supports int/real (kind=i)
+## Example: LIBGFOR_CHECK_KIND(integer,8)
+AC_DEFUN([LIBGFOR_CHECK_KIND],[
+  AC_CACHE_CHECK([for $1$2],
+  libgfor_cv_have_$1$2,[
+  FC_SRCEXT=f90
+  AC_LANG_PUSH([Fortran])
+  AC_COMPILE_IFELSE([
+  $1 (kind=$2) :: x
+  end],
+  [libgfor_cv_have_$1$2=yes],
+  [libgfor_cv_have_$1$2=no])
+  AC_LANG_POP
+  ])
+])
+
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/configure.ac gcc-4.0.1/libgfortran/configure.ac
--- /usr1/rtems/work-tools/original/gcc-4.0.1/libgfortran/configure.ac	Wed Jun 15 13:53:25 2005
+++ gcc-4.0.1/libgfortran/configure.ac	Wed Aug 10 12:08:46 2005
@@ -251,6 +251,18 @@
 # have C99 integer types at all.
 LIBGFOR_TARGET_ILP32
 
+LIBGFOR_CHECK_KIND(integer,1)
+LIBGFOR_CHECK_KIND(integer,2)
+LIBGFOR_CHECK_KIND(integer,4)
+LIBGFOR_CHECK_KIND(integer,8)
+LIBGFOR_CHECK_KIND(integer,16)
+LIBGFOR_CHECK_KIND(real,4)
+LIBGFOR_CHECK_KIND(real,8)
+LIBGFOR_CHECK_KIND(real,10)
+LIBGFOR_CHECK_KIND(real,16)
+
+AM_CONDITIONAL(LIBGFORTRAN,[test "$libgfor_cv_have_real8" = yes])
+
 # Check out attribute support.
 LIBGFOR_CHECK_ATTRIBUTE_VISIBILITY
 LIBGFOR_CHECK_ATTRIBUTE_DLLEXPORT
diff -uNr /usr1/rtems/work-tools/original/gcc-4.0.1/libjava/configure.ac gcc-4.0.1/libjava/configure.ac
--- /usr1/rtems/work-tools/original/gcc-4.0.1/libjava/configure.ac	Wed Apr  6 16:38:26 2005
+++ gcc-4.0.1/libjava/configure.ac	Wed Aug 10 12:08:46 2005
@@ -627,6 +627,8 @@
 	;;
     esac
     ;;
+ rtems)
+    ;;
  win32)
     ;;
  decosf1 | irix | mach | os2 | solaris | dce | vxworks)
